unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    N     :Integer;
    alpha :double;
    K     :double;
    procedure Gilka( x1,y1,x2,y2 :double; Kilkist :Integer);
    procedure Hmara( x, y, r: double; Kilkist :Integer);
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }
procedure TForm1.Gilka( x1,y1,x2,y2 :double; Kilkist :Integer);
var R,G,B :Integer;
    xp,yp,xk,yk :double;
    xk1,yk1     :double;
    xk2,yk2     :double;
begin
  R := 46;
  G := 139;
  B := 87;
  Image1.Canvas.Pen.Color := R + G*256 + B*256*256;
  //Задали колір

  //Малюємо гілку
  Image1.Canvas.Line(round(x1),round(y1),round(x2),round(y2));

  //Якщо кількість поторів більша за нулб, то додаємо гілки
  if Kilkist>0 then
  begin
    Kilkist := Kilkist - 1;  //Зменшуємо кількість, щоб не салювало до нескінченності
    xp := x1;   yp := y1;    //Початок нової гілки
    xk := x1 + (x2-x1)*K;    //Пропорційно зменшуємо гілку
    yk := y1 + (y2-y1)*K;


     //Домальовуємо гілку
    Gilka(x2, y2, x2 + (xk-xp), y2 + (yk-yp), Kilkist);
     //Пересуваємо зменшену гілку до теперішньої гілки
    xp := xp + (x1+x2)* 0.5 - x1;
    xk := xk + (x1+x2)* 0.5 - x1;
    yp := yp + (y1+y2)* 0.5 - y1;
    yk := yk + (y1+y2)* 0.5- y1;
     //Домальовуємо вершок
    Gilka(x2, y2, x2 + (xk-xp), y2 + (yk-yp), Kilkist);
    //Пересуваємо зменшену гілку до середени теперішньої гілки
    xp := xp + (x1+x2)/2 - x1;
    xk := xk + (x1+x2)/2 - x1;
    yp := yp + (y1+y2)/2 - y1;
    yk := yk + (y1+y2)/2 - y1;

    //Повернути в одну сторону
    xk1 := xp + (xk-xp)*cos(alpha) - (yk-yp)*sin(alpha);
    yk1 := yp + (xk-xp)*sin(alpha) + (yk-yp)*cos(alpha);
    Gilka(xp,yp,xk1,yk1,Kilkist);

    //Повернути в іншу сторону
    xk2 := xp + (xk-xp)*cos(-alpha) - (yk-yp)*sin(-alpha);
    yk2 := yp + (xk-xp)*sin(-alpha) + (yk-yp)*cos(-alpha);
    Gilka(xp,yp,xk2,yk2,Kilkist);

  end;

end;

procedure TForm1.Hmara( x, y, r: double; Kilkist :Integer);
var nomer:Integer;
    kut :double;
    Rk, G, B: Integer;
    m : Integer;
begin
  Rk := 30;
  G := 144;
  B := 255;
  m := random(7)+3;
  Image1.Canvas.Pen.Color := Rk + G*256 + B*256*256;
  // Image1.Canvas.
  Image1.Canvas.Ellipse( round(x - r), round( y - r/3.0), round(x+r), round(y + r/3.0) );
  Image1.Canvas.brush.Color :=Rk + G*256 + B*256*256;
  Kilkist := Kilkist - 1;
  if (r > 10.0)and(Kilkist >= 0)  then
  begin
    for nomer:=0 to m-1 do
    begin
      kut := 2.0*PI/m * nomer;
      Hmara( x + cos(kut)*r, y + sin(kut)*r/3.0, r*K, Kilkist);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  N := TrackBar1.Position;
  alpha := StrToFloat( Edit1.Text );
  alpha := alpha / 180.0 * PI;
  K := 1.0/2.0;
  Image1.Canvas.Brush.Color:=0;
  Image1.Canvas.FillRect(0,0,300,300);
  Gilka( 150, 300, 150, 150, N);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  N := TrackBar1.Position;
  K := 1.0/1.5;
  Image1.Canvas.Brush.Color:=0;
  Image1.Canvas.FillRect(0,0,300,300);
  Hmara( 150, 150, 50, N);
end;

end.

